enum T  { TI(int), TS(~str) }

fn int_or_fail (i: T) -> int {
  match (i) {
    TI (i) => { i }
    TS (_) => { fail!("error") }
  }
}

fn str_or_fail (i: T) -> ~str {
  match (i) {
    TI (_) => { fail!("error") }
    TS (s) => { s }
  }
}

fn plus (lhs: T, rhs: T) -> T {
  TI(int_or_fail (lhs) + int_or_fail (rhs))
}

fn concat (lhs: T, rhs: T) -> T {
   TS(str_or_fail (lhs) + str_or_fail (rhs))
}

fn display(t: &T) {
  match (*t) {
    TI(i) => { println(fmt!("int: %d", i)) }
    TS(ref s) => { println(fmt!("str: %s", *s)) }
  }
}

fn main() {
  let d1 = TI(1);
  let d2 = TI(2);
  let x = plus(d1, d2);
  display(&x);

  let d1 = TS(~"Hello, ");
  let d2 = TS(~"World");
  let y = concat (d1,d2);
  display(&y);

  // Runtime error in concat here
  let z = concat(x, y);
  display(&z);
}
